&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r2 GUI ADM1
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME W-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS W-Win 
/*------------------------------------------------------------------------

  File: 

  Description: from cntnrwin.w - ADM SmartWindow Template

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  History: 
          
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */


&Scoped-define QBS-DIAG              NO
&Scoped-define QBS-COMBO-ENABLE      NO
&Scoped-define QBS-SELLIST-ENABLE    NO
&Scoped-define QBS-WORDFIND          NO
&Scoped-define QBS-LOOKUP            Lookup,ams/win/0lk/am-proj1,smart-window,f-proj#
&Scoped-define QBS-LOOK-ASSIGN      


/* Parameters Definitions ---                                           */
def var wh as handle extent 5.

/* Local Variable Definitions ---                                       */
define            var v-ok      as log.
define            var v-status  as log.



{mkt/w2k/inc.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartWindow
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER WINDOW

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME F-Main

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS BUTTON-156 BUTTON-157 BUTTON-1 BUTTON-158 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR W-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of handles for OCX Containers                            */
DEFINE VARIABLE cjDocking AS WIDGET-HANDLE NO-UNDO.
DEFINE VARIABLE chcjDocking AS COMPONENT-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON BUTTON-1 
     LABEL "Parent" 
     SIZE 15 BY 1.14.

DEFINE BUTTON BUTTON-156 
     LABEL "Init" 
     SIZE 9 BY 1.14.

DEFINE BUTTON BUTTON-157 
     LABEL "W1" 
     SIZE 9 BY 1.14.

DEFINE BUTTON BUTTON-158 
     LABEL "Add Pane" 
     SIZE 20 BY 1.14.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME F-Main
     BUTTON-156 AT ROW 12.19 COL 2
     BUTTON-157 AT ROW 12.19 COL 16
     BUTTON-1 AT ROW 12.19 COL 36
     BUTTON-158 AT ROW 12.19 COL 53
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 80 BY 12.95.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartWindow
   Allow: Basic,Browse,DB-Fields,Query,Smart,Window
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW W-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "<insert SmartWindow title>"
         HEIGHT             = 12.95
         WIDTH              = 80
         MAX-HEIGHT         = 17
         MAX-WIDTH          = 80
         VIRTUAL-HEIGHT     = 17
         VIRTUAL-WIDTH      = 80
         RESIZE             = no
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB W-Win 
/* ************************* Included-Libraries *********************** */

{src/adm/method/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW W-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME F-Main
                                                                        */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(W-Win)
THEN W-Win:HIDDEN = yes.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 


/* **********************  Create OCX Containers  ********************** */

&ANALYZE-SUSPEND _CREATE-DYNAMIC

&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN

CREATE CONTROL-FRAME cjDocking ASSIGN
       FRAME           = FRAME F-Main:HANDLE
       ROW             = 1
       COLUMN          = 1
       HEIGHT          = 10.24
       WIDTH           = 74
       HIDDEN          = yes
       SENSITIVE       = yes.

PROCEDURE adm-create-controls:
      cjDocking:NAME = "cjDocking":U .
/* cjDocking OCXINFO:CREATE-CONTROL from: {DDAED5D4-928B-478E-9FA9-61FC05085214} type: DockingPane */
      cjDocking:MOVE-BEFORE(BUTTON-156:HANDLE IN FRAME F-Main).

END PROCEDURE.

&ENDIF

&ANALYZE-RESUME /* End of _CREATE-DYNAMIC */


/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME W-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL W-Win W-Win
ON END-ERROR OF W-Win /* <insert SmartWindow title> */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL W-Win W-Win
ON WINDOW-CLOSE OF W-Win /* <insert SmartWindow title> */
DO:
  /* This ADM code must be left here in order for the SmartWindow
     and its descendents to terminate properly on exit. */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BUTTON-1
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BUTTON-1 W-Win
ON CHOOSE OF BUTTON-1 IN FRAME F-Main /* Parent */
DO:
  def var v-n as int.
  run ip-parent (this-procedure, output v-n).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BUTTON-156
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BUTTON-156 W-Win
ON CHOOSE OF BUTTON-156 IN FRAME F-Main /* Init */
DO:
  chCjDocking = chcjDocking:controls:item(1).
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BUTTON-157
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BUTTON-157 W-Win
ON CHOOSE OF BUTTON-157 IN FRAME F-Main /* W1 */
DO:
  run mkt/w2k/win1.w persistent set wh[1].
  run ip-parent (wh[1]).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BUTTON-158
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BUTTON-158 W-Win
ON CHOOSE OF BUTTON-158 IN FRAME F-Main /* Add Pane */
DO:
    def var chpane as com-handle extent 5.
    def var v-n    as int initial 1.
    def var h-i    as int .
    define var ch-i as int.
run mkt/w2k/win2.w persistent set wh[v-n].
run ip-geth  in wh[v-n] (output h-i) no-error.
    run ip-newparent3  (h-i,  output ch-i).

    chPane[v-n] = chcjDocking:createPane(1, 200,120,0, '').
    chPane[v-n]:title = 'Pane1'.
    /*v-n = v-n + 1.
    chPane[v-n] = chcjDocking:createPane(2, 200,120,1, '').*/

    /*chcjDocking:AttachPane( chPane[2], chPane[1]). */
message 'well' chcjDocking:options:hideClient view-as alert-box.
    chcjDocking:ShowPane(1).
    chcjDocking:options:hideClient = true.
    /*chcjDocking:ShowPane(2).*/
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME cjDocking
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL cjDocking W-Win OCX.AttachPane
PROCEDURE cjDocking.DockingPane.AttachPane .
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  Required for OCX.
    Item
  Notes:       
------------------------------------------------------------------------------*/

DEFINE input /*-OUTPUT*/ PARAMETER p-Item AS COM-HANDLE NO-UNDO.
define var ch-i as int.
define var h-i  as handle.
define var v-n  as int initial 1.
message 'AttachePane' string(p-item) valid-handle(wh[v-n]) v-ok view-as alert-box.

if not valid-handle(wh[v-n]) then do:
    /*run ip-gethwnd in wh[v-n] (output ch-i). 
    run ip-setparent in wh[v-n] (this-procedure).
    run ip-geth    in wh[v-n] (output h-i).
    p-item:handle = ch-i. /* makes no difference  */ */
    /*run ip-parent              (wh[1], output ch-i). */
    
    /* Test2 - Kinda works 
    run ip-parent in wh[v-n] (this-procedure, output ch-i).  */
end.

/* Test 3 */
    if p-item= wh[v-n] then do:
        run ip-geth    in wh[v-n] (output h-i).
        p-item:handle = ch-i.
    end.


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK W-Win 


/* ***************************  Main Block  *************************** */

/* Include custom  Main Block code for SmartWindows. */


{src/adm/template/windowmn.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects W-Win  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-row-available W-Win  _ADM-ROW-AVAILABLE
PROCEDURE adm-row-available :
/*------------------------------------------------------------------------------
  Purpose:     Dispatched to this procedure when the Record-
               Source has a new row available.  This procedure
               tries to get the new row (or foriegn keys) from
               the Record-Source and process it.
  Parameters:  <none>
------------------------------------------------------------------------------*/

  /* Define variables needed by this internal procedure.             */
  {src/adm/template/row-head.i}

  /* Process the newly available records (i.e. display fields,
     open queries, and/or pass records on to any RECORD-TARGETS).    */
  {src/adm/template/row-end.i}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE control_load W-Win  _CONTROL-LOAD
PROCEDURE control_load :
/*------------------------------------------------------------------------------
  Purpose:     Load the OCXs    
  Parameters:  <none>
  Notes:       Here we load, initialize and make visible the 
               OCXs in the interface.                        
------------------------------------------------------------------------------*/

&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN
DEFINE VARIABLE UIB_S    AS LOGICAL    NO-UNDO.
DEFINE VARIABLE OCXFile  AS CHARACTER  NO-UNDO.

OCXFile = SEARCH( "w-main4.wrx":U ).
IF OCXFile = ? THEN
  OCXFile = SEARCH(SUBSTRING(THIS-PROCEDURE:FILE-NAME, 1,
                     R-INDEX(THIS-PROCEDURE:FILE-NAME, ".":U), "CHARACTER":U) + "wrx":U).

IF OCXFile <> ? THEN
DO:
  ASSIGN
    chcjDocking = cjDocking:COM-HANDLE
    UIB_S = chcjDocking:LoadControls( OCXFile, "cjDocking":U)
  .
  RUN DISPATCH IN THIS-PROCEDURE("initialize-controls":U) NO-ERROR.
END.
ELSE MESSAGE "w-main4.wrx":U SKIP(1)
             "The binary control file could not be found. The controls cannot be loaded."
             VIEW-AS ALERT-BOX TITLE "Controls Not Loaded".

&ENDIF

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI W-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(W-Win)
  THEN DELETE WIDGET W-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI W-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  ENABLE BUTTON-156 BUTTON-157 BUTTON-1 BUTTON-158 
      WITH FRAME F-Main IN WINDOW W-Win.
  {&OPEN-BROWSERS-IN-QUERY-F-Main}
  VIEW W-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ip-control W-Win 
PROCEDURE ip-control :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
define input parameter p-action as char no-undo.
define var v-char-handle as char no-undo.

case entry(1,p-action):
    when ' ':U then do with frame {&FRAME-NAME}:
    
    end. /* end < > */
end case. 

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ip-newparent3 W-Win 
PROCEDURE ip-newparent3 :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
define input parameter phProcedure AS HANDLE NO-UNDO.

    DEFINE VAR hWindowhandle AS HANDLE  .
    DEFINE VAR hWindowHWND   AS INTEGER .
    DEFINE output parameter hHWND         AS INTEGER .
    /*ASSIGN hWindowHandle = phProcedure:CURRENT-WINDOW
           hWindowHWND   = hWindowhandle:HWND. */

    run ip-gethwnd in wh[1] (output hWindowHWND).
/*message 'ok' valid-handle(wh[1]) string(wh[1]) string(hWindowHWND) view-as alert-box.*/
    RUN getParent (INPUT hWindowHWND, OUTPUT hWindowHWND).
/*message  string(hWindowHWND) string(w-win:hwnd) view-as alert-box. */
    RUN setParent (INPUT hWindowHWND, INPUT w-win:hwnd , output hHWND ).
/*message 'win2HWND=' string(hhwnd) view-as alert-box. */
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ip-parent W-Win 
PROCEDURE ip-parent :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    define input parameter phProcedure AS HANDLE NO-UNDO.
  
    DEFINE VAR hWindowhandle AS HANDLE  .
    DEFINE VAR hWindowHWND   AS INTEGER .
    DEFINE output parameter hHWND         AS INTEGER .
    ASSIGN hWindowHandle = phProcedure:CURRENT-WINDOW
           hWindowHWND   = hWindowhandle:HWND.

    RUN getParent (INPUT hWindowHWND, OUTPUT hWindowHWND).
    RUN setParent (INPUT hWindowHWND, INPUT CURRENT-WINDOW:hwnd , output hHWND ).
message 'win2HWND=' string(hhwnd) view-as alert-box.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE local-exit W-Win 
PROCEDURE local-exit :
/* -----------------------------------------------------------
  Purpose:  Starts an "exit" by APPLYing CLOSE event, which starts "destroy".
  Parameters:  <none>
  Notes:    If activated, should APPLY CLOSE, *not* dispatch adm-exit.   
-------------------------------------------------------------*/
   APPLY "CLOSE":U TO THIS-PROCEDURE.
   
   RETURN.
       
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE local-initialize W-Win 
PROCEDURE local-initialize :
/*------------------------------------------------------------------------------
  Purpose:     Override standard ADM method
  Notes:       
------------------------------------------------------------------------------*/

  /* Code placed here will execute PRIOR to standard behavior. */

  /* Dispatch standard ADM method.                             */
  RUN dispatch IN THIS-PROCEDURE ( INPUT 'initialize':U ) .

  /* Code placed here will execute AFTER standard behavior.    */
  chCjDocking = chcjDocking:controls:item(1).
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE send-records W-Win  _ADM-SEND-RECORDS
PROCEDURE send-records :
/*------------------------------------------------------------------------------
  Purpose:     Send record ROWID's for all tables used by
               this file.
  Parameters:  see template/snd-head.i
------------------------------------------------------------------------------*/

  /* SEND-RECORDS does nothing because there are no External
     Tables specified for this SmartWindow, and there are no
     tables specified in any contained Browse, Query, or Frame. */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE state-changed W-Win 
PROCEDURE state-changed :
/* -----------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
-------------------------------------------------------------*/
  DEFINE INPUT PARAMETER p-issuer-hdl AS HANDLE NO-UNDO.
  DEFINE INPUT PARAMETER p-state AS CHARACTER NO-UNDO.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

